# -*- coding: euc-jp -*-

import pygame
from pygame.locals import *
import sys,re,os
import codecs
import demoutils

TTFFILE = "mincho.ttf"
TYPEWAV = "lup1.wav"
JINGLEWAV = "lup2.wav"

DEFAULTWIDTH = 1024
DEFAULTHEIGHT = 768

BIGFSZ = 550
SMALLFSZ = 100

WAVKICKSTARTWAIT = 0.15  # lup1.wav Ω夬ˤ֡Ϥ lup1.wav ¸
INTERVAL = 0.18

BLACK = pygame.color.Color("black")
WHITE = pygame.color.Color("white")

def init():
    global w1, w2, fnt1, fnt2
    w1 = pygame.mixer.Sound(TYPEWAV)
    w2 = pygame.mixer.Sound(JINGLEWAV)
    fnt1 = pygame.font.Font(TTFFILE, BIGFSZ)
    fnt2 = pygame.font.Font(TTFFILE, SMALLFSZ)

ENDEV = USEREVENT + 1

def doit1char(ch, scr):
    fs = fnt1.render(ch, 1, WHITE)
    fw = fs.get_width()
    fh = fs.get_height()
    scr.fill(BLACK)
    scr.blit(fs, (scr.get_width()/2-fw/2, scr.get_height()/2-fh/2))

re1 = re.compile(u"[\r\n 	]+")

def slide(mesg, waitsecs=None):
    init()
    scr = pygame.display.get_surface()
    w1.play()
    demoutils.waitsec(WAVKICKSTARTWAIT)
    cnt = 0
#    xmesg = re1.sub(" ", mesg.strip())
    xmesg = re1.sub(" ", mesg.strip())
    for i in range(len(xmesg)):
        ch = xmesg[i]
        if ch == ';':
            ch = ' '
        doit1char(ch, scr)
        pygame.display.update()
        demoutils.waitsec(INTERVAL-WAVKICKSTARTWAIT)
        if i < len(xmesg)-1 and (xmesg[i+1] not in " ;"):
            w1.play()
        demoutils.waitsec(WAVKICKSTARTWAIT)

    w2.play()
    s = renderText(fnt2, mesg.replace(";", ""))
    sx = scr.get_width()/2-s.get_width()/2
    sy = scr.get_height()/2-s.get_height()/2
    scr.fill(BLACK)
    scr.blit(s, (sx, sy))
    pygame.display.update()
    if waitsecs is not None:
        demoutils.waitsec(w2.get_length() + waitsecs)

def renderText(font, text):
    lines = text.split("\n")
    surfaces = []
    poses = []
    w = 0
    h = 0
    for l in lines:
        l = l.replace("\r", "")
        s = font.render(l, 1, WHITE)
        sw = s.get_width()
        sh = s.get_height()
        surfaces.append(s)
        poses.append((0, h))
        w = max(w, sw)
        h += sh

    rv = pygame.Surface((w, h))

    for i in range(len(surfaces)):
        rv.blit(surfaces[i], poses[i])
    return rv

EXTRASECS = 1

def main():
    if sys.argv[1] == '-f':
        m = file(sys.argv[2]).read()
    else:
        m = sys.argv[1]
    m = codecs.getdecoder("euc-jp")(m)[0]
    pygame.init()
    pygame.display.set_mode((DEFAULTWIDTH, DEFAULTHEIGHT), FULLSCREEN)
    demoutils.fullscreenwait()
    try:
        slide(m, EXTRASECS)
    except demoutils.DemoException:
        pass

if __name__ == '__main__':
    main()
