import os,sys,re
import email
import getdist
import codecs
import types
import math

origD = "good"
exkkD = "good-ex-kk"
targetD = "g100-vecs"
popFileLog = None

maxNormal = 0.99999999

headers = ('from', 'to', 'cc', 'subject')
globDistFile = "s2000.dist"

NWORDDIST = 3
NLINEDIST = 3

class Classifier:
    pass

class CharClassifier(Classifier):
    def __init__(self):
        self.d = [0]*8
        self.cnt = 0

    def add(self, c):
        code = ord(c)
        if code < 16 or code == 32:
            return
        code = code / 16 - 1
        if code > 7:
            code = 7
        self.d[code] += 1
        self.cnt += 1

    def __repr__(self):
        rv = ""
        tot = float(self.cnt)
        for i in xrange(1, len(self.d)):
            rv += "%s\n" % (self.d[i] / tot)
        return rv

def getNumOfPayloads(sth):
    if type(sth) == list:
        return sum(map(lambda x: getNumOfPayloads(x), sth))
    elif isStr(sth):
        if len(sth) > 0:
            return 1
        return 0
    elif isEMailObj(sth):
        return getNumOfPayloads(sth.get_payload(decode=False))
    else:
        # blob?
        return 1

def isEMailObj(x):
    return type(x) == types.InstanceType and x.__class__ == email.Message.Message

def isStr(s):
    return type(s) in (str, unicode)

_gd = None
def globDist():
    global _gd
    if _gd is None:
        _gd = getdist.dist(globDistFile)
    return _gd

def normalize(val, maxv):
    rv = math.log(val+1.0)/math.log(maxv)
    if rv >= 1.0:
        rv = maxNormal
    return rv

def doit(origMailFile, exKkUcMailFile, prob, toFile):
    om = email.message_from_file(origMailFile)
    cms = exKkUcMailFile.read()
    cmsmain = getdist.filterOutHeaders(cms, headers)

    cc = CharClassifier()
    for c in cmsmain:
        cc.add(c)
    toFile.write(repr(cc))

    toFile.write("%s\n" % normalize(len(cmsmain), (1<<25)))
    toFile.write("%s\n" % normalize(cmsmain.count("\n"), (1<<16)))
    toFile.write("%s\n" % normalize(getNumOfPayloads(om), 20))

    d = getdist.dist()
    d.add(cmsmain, headers=headers, multipleCount=True)

    tv = []
    for w in d.d:
        if d.d[w] > 1:
            tv.append((d.d[w], w))
    tv.sort()
    tv.reverse()
    all = globDist()
    for i in xrange(NWORDDIST):
        try:
            v = all.d[tv[i][1]]/float(all.cnt)
        except:
            v = 0
        toFile.write("%s\n" % v)

    ld = [len(l) for l in cmsmain.split("\n")]
    ld.sort()
    for i in xrange(NLINEDIST):
        try:
            if i == NLINEDIST-1:
                maxv = 1000
            else:
                maxv = ld[-1]
            idx = len(ld)*(i+1)/NLINEDIST-1
            v = normalize(ld[idx], maxv)
        except:
            v = 0
        toFile.write("%s\n" % v)

    if prob == 0:
        pv = 0
    else:
        pv = maxNormal-min(-math.log(prob)/300.0, maxNormal)
    toFile.write("%s\n" % pv)

def doit1file(origfn, exkkucfn, prob, tofn, overwriteF=False):
    if os.path.exists(tofn) and not overwriteF:
        print "%s already exists, skipping..." % tofn
        return
    w = file(tofn, "w")
    r1 = file(origfn)
    r2 = codecs.open(exkkucfn, "r", "utf-8")
    doit(r1, r2, prob, w)
    r1.close()
    r2.close()
    w.close()

def oldmain():
    if len(sys.argv) == 5 and os.path.isfile(sys.argv[1]):
        doit1file(sys.argv[1], sys.argv[2], float(sys.argv[3]), sys.argv[4])

popFileLogBody = None

def getProbFromPopLog(tag):
    global popFileLogBody
    if popFileLogBody is None:
        if popFileLog is None:
            return 0
        popFileLogBody = file(popFileLog).read()
    needle = "/%s' is `" % tag
    pos = popFileLogBody.index(needle)
    pos2 = popFileLogBody.rindex("good", 0, pos)+4
    pos3 = popFileLogBody.index("\n", pos2)
    return float(popFileLogBody[pos2:pos3])

def main():
    for tag in sys.argv[1:]:
        prob = getProbFromPopLog(tag)
        doit1file(os.path.join(origD, tag),
                  os.path.join(exkkD, tag),
                  prob,
                  os.path.join(targetD, tag),
                  overwriteF=True)

main()
